// Code generated by protoc-gen-go-frostfs. DO NOT EDIT.

package ape

import (
	json "encoding/json"
	fmt "fmt"
	pool "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/pool"
	proto "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/proto"
	encoding "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/proto/encoding"
	easyproto "github.com/VictoriaMetrics/easyproto"
	jlexer "github.com/mailru/easyjson/jlexer"
	jwriter "github.com/mailru/easyjson/jwriter"
	strconv "strconv"
)

type TargetType int32

const (
	TargetType_UNDEFINED TargetType = 0
	TargetType_NAMESPACE TargetType = 1
	TargetType_CONTAINER TargetType = 2
	TargetType_USER      TargetType = 3
	TargetType_GROUP     TargetType = 4
)

var (
	TargetType_name = map[int32]string{
		0: "UNDEFINED",
		1: "NAMESPACE",
		2: "CONTAINER",
		3: "USER",
		4: "GROUP",
	}
	TargetType_value = map[string]int32{
		"UNDEFINED": 0,
		"NAMESPACE": 1,
		"CONTAINER": 2,
		"USER":      3,
		"GROUP":     4,
	}
)

func (x TargetType) String() string {
	if v, ok := TargetType_name[int32(x)]; ok {
		return v
	}
	return strconv.FormatInt(int64(x), 10)
}
func (x *TargetType) FromString(s string) bool {
	if v, ok := TargetType_value[s]; ok {
		*x = TargetType(v)
		return true
	}
	return false
}

type ChainTarget struct {
	Type TargetType `json:"type"`
	Name string     `json:"name"`
}

var (
	_ encoding.ProtoMarshaler   = (*ChainTarget)(nil)
	_ encoding.ProtoUnmarshaler = (*ChainTarget)(nil)
	_ json.Marshaler            = (*ChainTarget)(nil)
	_ json.Unmarshaler          = (*ChainTarget)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *ChainTarget) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.EnumSize(1, int32(x.Type))
	size += proto.StringSize(2, x.Name)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *ChainTarget) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *ChainTarget) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if int32(x.Type) != 0 {
		mm.AppendInt32(1, int32(x.Type))
	}
	if len(x.Name) != 0 {
		mm.AppendString(2, x.Name)
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *ChainTarget) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "ChainTarget")
		}
		switch fc.FieldNum {
		case 1: // Type
			data, ok := fc.Int32()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Type")
			}
			x.Type = TargetType(data)
		case 2: // Name
			data, ok := fc.String()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Name")
			}
			x.Name = data
		}
	}
	return nil
}
func (x *ChainTarget) GetType() TargetType {
	if x != nil {
		return x.Type
	}
	return 0
}
func (x *ChainTarget) SetType(v TargetType) {
	x.Type = v
}
func (x *ChainTarget) GetName() string {
	if x != nil {
		return x.Name
	}
	return ""
}
func (x *ChainTarget) SetName(v string) {
	x.Name = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *ChainTarget) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *ChainTarget) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"type\":"
		out.RawString(prefix)
		v := int32(x.Type)
		if vv, ok := TargetType_name[v]; ok {
			out.String(vv)
		} else {
			out.Int32(v)
		}
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"name\":"
		out.RawString(prefix)
		out.String(x.Name)
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *ChainTarget) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *ChainTarget) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "type":
			{
				var f TargetType
				var parsedValue TargetType
				switch v := in.Interface().(type) {
				case string:
					if vv, ok := TargetType_value[v]; ok {
						parsedValue = TargetType(vv)
						break
					}
					vv, err := strconv.ParseInt(v, 10, 32)
					if err != nil {
						in.AddError(err)
						return
					}
					parsedValue = TargetType(vv)
				case float64:
					parsedValue = TargetType(v)
				}
				f = parsedValue
				x.Type = f
			}
		case "name":
			{
				var f string
				f = in.String()
				x.Name = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type Chain struct {
	Kind isChain_Kind
}

var (
	_ encoding.ProtoMarshaler   = (*Chain)(nil)
	_ encoding.ProtoUnmarshaler = (*Chain)(nil)
	_ json.Marshaler            = (*Chain)(nil)
	_ json.Unmarshaler          = (*Chain)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *Chain) StableSize() (size int) {
	if x == nil {
		return 0
	}
	if inner, ok := x.Kind.(*Chain_Raw); ok {
		size += proto.BytesSize(1, inner.Raw)
	}
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *Chain) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *Chain) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if inner, ok := x.Kind.(*Chain_Raw); ok {
		if len(inner.Raw) != 0 {
			mm.AppendBytes(1, inner.Raw)
		}
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *Chain) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "Chain")
		}
		switch fc.FieldNum {
		case 1: // Raw
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Raw")
			}
			x.Kind = &Chain_Raw{Raw: data}
		}
	}
	return nil
}
func (x *Chain) GetKind() isChain_Kind {
	if x != nil {
		return x.Kind
	}
	return nil
}
func (x *Chain) SetKind(v isChain_Kind) {
	x.Kind = v
}
func (x *Chain) GetRaw() []byte {
	if xx, ok := x.GetKind().(*Chain_Raw); ok {
		return xx.Raw
	}
	return nil
}
func (x *Chain) SetRaw(v *Chain_Raw) {
	x.Kind = v
}
func (x *Chain_Raw) GetRaw() []byte {
	if x != nil {
		return x.Raw
	}
	return nil
}
func (x *Chain_Raw) SetRaw(v []byte) {
	x.Raw = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *Chain) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *Chain) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	switch xx := x.Kind.(type) {
	case *Chain_Raw:
		{
			if !first {
				out.RawByte(',')
			} else {
				first = false
			}
			const prefix string = "\"raw\":"
			out.RawString(prefix)
			if xx.Raw != nil {
				out.Base64Bytes(xx.Raw)
			} else {
				out.String("")
			}
		}
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *Chain) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *Chain) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "raw":
			xx := new(Chain_Raw)
			x.Kind = xx
			{
				var f []byte
				f = in.Bytes()
				xx.Raw = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type isChain_Kind interface {
	isChain_Kind()
}

type Chain_Raw struct {
	Raw []byte
}

func (*Chain_Raw) isChain_Kind() {}
