// Code generated by protoc-gen-go-frostfs. DO NOT EDIT.

package refs

import (
	json "encoding/json"
	fmt "fmt"
	pool "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/pool"
	proto "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/proto"
	encoding "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/util/proto/encoding"
	easyproto "github.com/VictoriaMetrics/easyproto"
	jlexer "github.com/mailru/easyjson/jlexer"
	jwriter "github.com/mailru/easyjson/jwriter"
	strconv "strconv"
)

type SignatureScheme int32

const (
	SignatureScheme_ECDSA_SHA512                        SignatureScheme = 0
	SignatureScheme_ECDSA_RFC6979_SHA256                SignatureScheme = 1
	SignatureScheme_ECDSA_RFC6979_SHA256_WALLET_CONNECT SignatureScheme = 2
)

var (
	SignatureScheme_name = map[int32]string{
		0: "ECDSA_SHA512",
		1: "ECDSA_RFC6979_SHA256",
		2: "ECDSA_RFC6979_SHA256_WALLET_CONNECT",
	}
	SignatureScheme_value = map[string]int32{
		"ECDSA_SHA512":                        0,
		"ECDSA_RFC6979_SHA256":                1,
		"ECDSA_RFC6979_SHA256_WALLET_CONNECT": 2,
	}
)

func (x SignatureScheme) String() string {
	if v, ok := SignatureScheme_name[int32(x)]; ok {
		return v
	}
	return strconv.FormatInt(int64(x), 10)
}
func (x *SignatureScheme) FromString(s string) bool {
	if v, ok := SignatureScheme_value[s]; ok {
		*x = SignatureScheme(v)
		return true
	}
	return false
}

type ChecksumType int32

const (
	ChecksumType_CHECKSUM_TYPE_UNSPECIFIED ChecksumType = 0
	ChecksumType_TZ                        ChecksumType = 1
	ChecksumType_SHA256                    ChecksumType = 2
)

var (
	ChecksumType_name = map[int32]string{
		0: "CHECKSUM_TYPE_UNSPECIFIED",
		1: "TZ",
		2: "SHA256",
	}
	ChecksumType_value = map[string]int32{
		"CHECKSUM_TYPE_UNSPECIFIED": 0,
		"TZ":                        1,
		"SHA256":                    2,
	}
)

func (x ChecksumType) String() string {
	if v, ok := ChecksumType_name[int32(x)]; ok {
		return v
	}
	return strconv.FormatInt(int64(x), 10)
}
func (x *ChecksumType) FromString(s string) bool {
	if v, ok := ChecksumType_value[s]; ok {
		*x = ChecksumType(v)
		return true
	}
	return false
}

type Address struct {
	ContainerId *ContainerID `json:"containerID"`
	ObjectId    *ObjectID    `json:"objectID"`
}

var (
	_ encoding.ProtoMarshaler   = (*Address)(nil)
	_ encoding.ProtoUnmarshaler = (*Address)(nil)
	_ json.Marshaler            = (*Address)(nil)
	_ json.Unmarshaler          = (*Address)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *Address) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.NestedStructureSize(1, x.ContainerId)
	size += proto.NestedStructureSize(2, x.ObjectId)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *Address) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *Address) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if x.ContainerId != nil {
		x.ContainerId.EmitProtobuf(mm.AppendMessage(1))
	}
	if x.ObjectId != nil {
		x.ObjectId.EmitProtobuf(mm.AppendMessage(2))
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *Address) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "Address")
		}
		switch fc.FieldNum {
		case 1: // ContainerId
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "ContainerId")
			}
			x.ContainerId = new(ContainerID)
			if err := x.ContainerId.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		case 2: // ObjectId
			data, ok := fc.MessageData()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "ObjectId")
			}
			x.ObjectId = new(ObjectID)
			if err := x.ObjectId.UnmarshalProtobuf(data); err != nil {
				return fmt.Errorf("unmarshal: %w", err)
			}
		}
	}
	return nil
}
func (x *Address) GetContainerId() *ContainerID {
	if x != nil {
		return x.ContainerId
	}
	return nil
}
func (x *Address) SetContainerId(v *ContainerID) {
	x.ContainerId = v
}
func (x *Address) GetObjectId() *ObjectID {
	if x != nil {
		return x.ObjectId
	}
	return nil
}
func (x *Address) SetObjectId(v *ObjectID) {
	x.ObjectId = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *Address) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *Address) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"containerID\":"
		out.RawString(prefix)
		x.ContainerId.MarshalEasyJSON(out)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"objectID\":"
		out.RawString(prefix)
		x.ObjectId.MarshalEasyJSON(out)
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *Address) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *Address) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "containerID":
			{
				var f *ContainerID
				f = new(ContainerID)
				f.UnmarshalEasyJSON(in)
				x.ContainerId = f
			}
		case "objectID":
			{
				var f *ObjectID
				f = new(ObjectID)
				f.UnmarshalEasyJSON(in)
				x.ObjectId = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type ObjectID struct {
	Value []byte `json:"value"`
}

var (
	_ encoding.ProtoMarshaler   = (*ObjectID)(nil)
	_ encoding.ProtoUnmarshaler = (*ObjectID)(nil)
	_ json.Marshaler            = (*ObjectID)(nil)
	_ json.Unmarshaler          = (*ObjectID)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *ObjectID) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.BytesSize(1, x.Value)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *ObjectID) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *ObjectID) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if len(x.Value) != 0 {
		mm.AppendBytes(1, x.Value)
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *ObjectID) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "ObjectID")
		}
		switch fc.FieldNum {
		case 1: // Value
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Value")
			}
			x.Value = data
		}
	}
	return nil
}
func (x *ObjectID) GetValue() []byte {
	if x != nil {
		return x.Value
	}
	return nil
}
func (x *ObjectID) SetValue(v []byte) {
	x.Value = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *ObjectID) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *ObjectID) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"value\":"
		out.RawString(prefix)
		if x.Value != nil {
			out.Base64Bytes(x.Value)
		} else {
			out.String("")
		}
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *ObjectID) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *ObjectID) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "value":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.Value = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type ContainerID struct {
	Value []byte `json:"value"`
}

var (
	_ encoding.ProtoMarshaler   = (*ContainerID)(nil)
	_ encoding.ProtoUnmarshaler = (*ContainerID)(nil)
	_ json.Marshaler            = (*ContainerID)(nil)
	_ json.Unmarshaler          = (*ContainerID)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *ContainerID) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.BytesSize(1, x.Value)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *ContainerID) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *ContainerID) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if len(x.Value) != 0 {
		mm.AppendBytes(1, x.Value)
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *ContainerID) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "ContainerID")
		}
		switch fc.FieldNum {
		case 1: // Value
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Value")
			}
			x.Value = data
		}
	}
	return nil
}
func (x *ContainerID) GetValue() []byte {
	if x != nil {
		return x.Value
	}
	return nil
}
func (x *ContainerID) SetValue(v []byte) {
	x.Value = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *ContainerID) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *ContainerID) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"value\":"
		out.RawString(prefix)
		if x.Value != nil {
			out.Base64Bytes(x.Value)
		} else {
			out.String("")
		}
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *ContainerID) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *ContainerID) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "value":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.Value = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type OwnerID struct {
	Value []byte `json:"value"`
}

var (
	_ encoding.ProtoMarshaler   = (*OwnerID)(nil)
	_ encoding.ProtoUnmarshaler = (*OwnerID)(nil)
	_ json.Marshaler            = (*OwnerID)(nil)
	_ json.Unmarshaler          = (*OwnerID)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *OwnerID) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.BytesSize(1, x.Value)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *OwnerID) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *OwnerID) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if len(x.Value) != 0 {
		mm.AppendBytes(1, x.Value)
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *OwnerID) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "OwnerID")
		}
		switch fc.FieldNum {
		case 1: // Value
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Value")
			}
			x.Value = data
		}
	}
	return nil
}
func (x *OwnerID) GetValue() []byte {
	if x != nil {
		return x.Value
	}
	return nil
}
func (x *OwnerID) SetValue(v []byte) {
	x.Value = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *OwnerID) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *OwnerID) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"value\":"
		out.RawString(prefix)
		if x.Value != nil {
			out.Base64Bytes(x.Value)
		} else {
			out.String("")
		}
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *OwnerID) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *OwnerID) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "value":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.Value = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type Version struct {
	Major uint32 `json:"major"`
	Minor uint32 `json:"minor"`
}

var (
	_ encoding.ProtoMarshaler   = (*Version)(nil)
	_ encoding.ProtoUnmarshaler = (*Version)(nil)
	_ json.Marshaler            = (*Version)(nil)
	_ json.Unmarshaler          = (*Version)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *Version) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.UInt32Size(1, x.Major)
	size += proto.UInt32Size(2, x.Minor)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *Version) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *Version) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if x.Major != 0 {
		mm.AppendUint32(1, x.Major)
	}
	if x.Minor != 0 {
		mm.AppendUint32(2, x.Minor)
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *Version) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "Version")
		}
		switch fc.FieldNum {
		case 1: // Major
			data, ok := fc.Uint32()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Major")
			}
			x.Major = data
		case 2: // Minor
			data, ok := fc.Uint32()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Minor")
			}
			x.Minor = data
		}
	}
	return nil
}
func (x *Version) GetMajor() uint32 {
	if x != nil {
		return x.Major
	}
	return 0
}
func (x *Version) SetMajor(v uint32) {
	x.Major = v
}
func (x *Version) GetMinor() uint32 {
	if x != nil {
		return x.Minor
	}
	return 0
}
func (x *Version) SetMinor(v uint32) {
	x.Minor = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *Version) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *Version) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"major\":"
		out.RawString(prefix)
		out.Uint32(x.Major)
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"minor\":"
		out.RawString(prefix)
		out.Uint32(x.Minor)
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *Version) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *Version) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "major":
			{
				var f uint32
				r := in.JsonNumber()
				n := r.String()
				v, err := strconv.ParseUint(n, 10, 32)
				if err != nil {
					in.AddError(err)
					return
				}
				pv := uint32(v)
				f = pv
				x.Major = f
			}
		case "minor":
			{
				var f uint32
				r := in.JsonNumber()
				n := r.String()
				v, err := strconv.ParseUint(n, 10, 32)
				if err != nil {
					in.AddError(err)
					return
				}
				pv := uint32(v)
				f = pv
				x.Minor = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type Signature struct {
	Key    []byte          `json:"key"`
	Sign   []byte          `json:"signature"`
	Scheme SignatureScheme `json:"scheme"`
}

var (
	_ encoding.ProtoMarshaler   = (*Signature)(nil)
	_ encoding.ProtoUnmarshaler = (*Signature)(nil)
	_ json.Marshaler            = (*Signature)(nil)
	_ json.Unmarshaler          = (*Signature)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *Signature) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.BytesSize(1, x.Key)
	size += proto.BytesSize(2, x.Sign)
	size += proto.EnumSize(3, int32(x.Scheme))
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *Signature) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *Signature) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if len(x.Key) != 0 {
		mm.AppendBytes(1, x.Key)
	}
	if len(x.Sign) != 0 {
		mm.AppendBytes(2, x.Sign)
	}
	if int32(x.Scheme) != 0 {
		mm.AppendInt32(3, int32(x.Scheme))
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *Signature) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "Signature")
		}
		switch fc.FieldNum {
		case 1: // Key
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Key")
			}
			x.Key = data
		case 2: // Sign
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Sign")
			}
			x.Sign = data
		case 3: // Scheme
			data, ok := fc.Int32()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Scheme")
			}
			x.Scheme = SignatureScheme(data)
		}
	}
	return nil
}
func (x *Signature) GetKey() []byte {
	if x != nil {
		return x.Key
	}
	return nil
}
func (x *Signature) SetKey(v []byte) {
	x.Key = v
}
func (x *Signature) GetSign() []byte {
	if x != nil {
		return x.Sign
	}
	return nil
}
func (x *Signature) SetSign(v []byte) {
	x.Sign = v
}
func (x *Signature) GetScheme() SignatureScheme {
	if x != nil {
		return x.Scheme
	}
	return 0
}
func (x *Signature) SetScheme(v SignatureScheme) {
	x.Scheme = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *Signature) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *Signature) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"key\":"
		out.RawString(prefix)
		if x.Key != nil {
			out.Base64Bytes(x.Key)
		} else {
			out.String("")
		}
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"signature\":"
		out.RawString(prefix)
		if x.Sign != nil {
			out.Base64Bytes(x.Sign)
		} else {
			out.String("")
		}
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"scheme\":"
		out.RawString(prefix)
		v := int32(x.Scheme)
		if vv, ok := SignatureScheme_name[v]; ok {
			out.String(vv)
		} else {
			out.Int32(v)
		}
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *Signature) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *Signature) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "key":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.Key = f
			}
		case "signature":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.Sign = f
			}
		case "scheme":
			{
				var f SignatureScheme
				var parsedValue SignatureScheme
				switch v := in.Interface().(type) {
				case string:
					if vv, ok := SignatureScheme_value[v]; ok {
						parsedValue = SignatureScheme(vv)
						break
					}
					vv, err := strconv.ParseInt(v, 10, 32)
					if err != nil {
						in.AddError(err)
						return
					}
					parsedValue = SignatureScheme(vv)
				case float64:
					parsedValue = SignatureScheme(v)
				}
				f = parsedValue
				x.Scheme = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type SignatureRFC6979 struct {
	Key  []byte `json:"key"`
	Sign []byte `json:"signature"`
}

var (
	_ encoding.ProtoMarshaler   = (*SignatureRFC6979)(nil)
	_ encoding.ProtoUnmarshaler = (*SignatureRFC6979)(nil)
	_ json.Marshaler            = (*SignatureRFC6979)(nil)
	_ json.Unmarshaler          = (*SignatureRFC6979)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *SignatureRFC6979) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.BytesSize(1, x.Key)
	size += proto.BytesSize(2, x.Sign)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *SignatureRFC6979) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *SignatureRFC6979) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if len(x.Key) != 0 {
		mm.AppendBytes(1, x.Key)
	}
	if len(x.Sign) != 0 {
		mm.AppendBytes(2, x.Sign)
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *SignatureRFC6979) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "SignatureRFC6979")
		}
		switch fc.FieldNum {
		case 1: // Key
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Key")
			}
			x.Key = data
		case 2: // Sign
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Sign")
			}
			x.Sign = data
		}
	}
	return nil
}
func (x *SignatureRFC6979) GetKey() []byte {
	if x != nil {
		return x.Key
	}
	return nil
}
func (x *SignatureRFC6979) SetKey(v []byte) {
	x.Key = v
}
func (x *SignatureRFC6979) GetSign() []byte {
	if x != nil {
		return x.Sign
	}
	return nil
}
func (x *SignatureRFC6979) SetSign(v []byte) {
	x.Sign = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *SignatureRFC6979) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *SignatureRFC6979) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"key\":"
		out.RawString(prefix)
		if x.Key != nil {
			out.Base64Bytes(x.Key)
		} else {
			out.String("")
		}
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"signature\":"
		out.RawString(prefix)
		if x.Sign != nil {
			out.Base64Bytes(x.Sign)
		} else {
			out.String("")
		}
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *SignatureRFC6979) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *SignatureRFC6979) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "key":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.Key = f
			}
		case "signature":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.Sign = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}

type Checksum struct {
	Type ChecksumType `json:"type"`
	Sum  []byte       `json:"sum"`
}

var (
	_ encoding.ProtoMarshaler   = (*Checksum)(nil)
	_ encoding.ProtoUnmarshaler = (*Checksum)(nil)
	_ json.Marshaler            = (*Checksum)(nil)
	_ json.Unmarshaler          = (*Checksum)(nil)
)

// StableSize returns the size of x in protobuf format.
//
// Structures with the same field values have the same binary size.
func (x *Checksum) StableSize() (size int) {
	if x == nil {
		return 0
	}
	size += proto.EnumSize(1, int32(x.Type))
	size += proto.BytesSize(2, x.Sum)
	return size
}

// MarshalProtobuf implements the encoding.ProtoMarshaler interface.
func (x *Checksum) MarshalProtobuf(dst []byte) []byte {
	m := pool.MarshalerPool.Get()
	defer pool.MarshalerPool.Put(m)
	x.EmitProtobuf(m.MessageMarshaler())
	dst = m.Marshal(dst)
	return dst
}

func (x *Checksum) EmitProtobuf(mm *easyproto.MessageMarshaler) {
	if x == nil {
		return
	}
	if int32(x.Type) != 0 {
		mm.AppendInt32(1, int32(x.Type))
	}
	if len(x.Sum) != 0 {
		mm.AppendBytes(2, x.Sum)
	}
}

// UnmarshalProtobuf implements the encoding.ProtoUnmarshaler interface.
func (x *Checksum) UnmarshalProtobuf(src []byte) (err error) {
	var fc easyproto.FieldContext
	for len(src) > 0 {
		src, err = fc.NextField(src)
		if err != nil {
			return fmt.Errorf("cannot read next field in %s", "Checksum")
		}
		switch fc.FieldNum {
		case 1: // Type
			data, ok := fc.Int32()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Type")
			}
			x.Type = ChecksumType(data)
		case 2: // Sum
			data, ok := fc.Bytes()
			if !ok {
				return fmt.Errorf("cannot unmarshal field %s", "Sum")
			}
			x.Sum = data
		}
	}
	return nil
}
func (x *Checksum) GetType() ChecksumType {
	if x != nil {
		return x.Type
	}
	return 0
}
func (x *Checksum) SetType(v ChecksumType) {
	x.Type = v
}
func (x *Checksum) GetSum() []byte {
	if x != nil {
		return x.Sum
	}
	return nil
}
func (x *Checksum) SetSum(v []byte) {
	x.Sum = v
}

// MarshalJSON implements the json.Marshaler interface.
func (x *Checksum) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	x.MarshalEasyJSON(&w)
	return w.Buffer.BuildBytes(), w.Error
}
func (x *Checksum) MarshalEasyJSON(out *jwriter.Writer) {
	if x == nil {
		out.RawString("null")
		return
	}
	first := true
	out.RawByte('{')
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"type\":"
		out.RawString(prefix)
		v := int32(x.Type)
		if vv, ok := ChecksumType_name[v]; ok {
			out.String(vv)
		} else {
			out.Int32(v)
		}
	}
	{
		if !first {
			out.RawByte(',')
		} else {
			first = false
		}
		const prefix string = "\"sum\":"
		out.RawString(prefix)
		if x.Sum != nil {
			out.Base64Bytes(x.Sum)
		} else {
			out.String("")
		}
	}
	out.RawByte('}')
}

// UnmarshalJSON implements the json.Unmarshaler interface.
func (x *Checksum) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	x.UnmarshalEasyJSON(&r)
	return r.Error()
}
func (x *Checksum) UnmarshalEasyJSON(in *jlexer.Lexer) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "type":
			{
				var f ChecksumType
				var parsedValue ChecksumType
				switch v := in.Interface().(type) {
				case string:
					if vv, ok := ChecksumType_value[v]; ok {
						parsedValue = ChecksumType(vv)
						break
					}
					vv, err := strconv.ParseInt(v, 10, 32)
					if err != nil {
						in.AddError(err)
						return
					}
					parsedValue = ChecksumType(vv)
				case float64:
					parsedValue = ChecksumType(v)
				}
				f = parsedValue
				x.Type = f
			}
		case "sum":
			{
				var f []byte
				{
					tmp := in.Bytes()
					if len(tmp) == 0 {
						tmp = nil
					}
					f = tmp
				}
				x.Sum = f
			}
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}
