package session

import (
	"git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/rpc/message"
	session "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/api/session/grpc"
)

func (c *ObjectSessionContext) MarshalJSON() ([]byte, error) {
	return message.MarshalJSON(c)
}

func (c *ObjectSessionContext) UnmarshalJSON(data []byte) error {
	return message.UnmarshalJSON(c, data, new(session.ObjectSessionContext))
}

func (l *TokenLifetime) MarshalJSON() ([]byte, error) {
	return message.MarshalJSON(l)
}

func (l *TokenLifetime) UnmarshalJSON(data []byte) error {
	return message.UnmarshalJSON(l, data, new(session.SessionToken_Body_TokenLifetime))
}

func (t *TokenBody) MarshalJSON() ([]byte, error) {
	return message.MarshalJSON(t)
}

func (t *TokenBody) UnmarshalJSON(data []byte) error {
	return message.UnmarshalJSON(t, data, new(session.SessionToken_Body))
}

func (t *Token) MarshalJSON() ([]byte, error) {
	return message.MarshalJSON(t)
}

func (t *Token) UnmarshalJSON(data []byte) error {
	return message.UnmarshalJSON(t, data, new(session.SessionToken))
}

func (x *XHeader) MarshalJSON() ([]byte, error) {
	return message.MarshalJSON(x)
}

func (x *XHeader) UnmarshalJSON(data []byte) error {
	return message.UnmarshalJSON(x, data, new(session.XHeader))
}

func (r *RequestMetaHeader) MarshalJSON() ([]byte, error) {
	return message.MarshalJSON(r)
}

func (r *RequestMetaHeader) UnmarshalJSON(data []byte) error {
	return message.UnmarshalJSON(r, data, new(session.RequestMetaHeader))
}

func (r *RequestVerificationHeader) MarshalJSON() ([]byte, error) {
	return message.MarshalJSON(r)
}

func (r *RequestVerificationHeader) UnmarshalJSON(data []byte) error {
	return message.UnmarshalJSON(r, data, new(session.RequestVerificationHeader))
}

func (r *ResponseMetaHeader) MarshalJSON() ([]byte, error) {
	return message.MarshalJSON(r)
}

func (r *ResponseMetaHeader) UnmarshalJSON(data []byte) error {
	return message.UnmarshalJSON(r, data, new(session.ResponseMetaHeader))
}

func (r *ResponseVerificationHeader) MarshalJSON() ([]byte, error) {
	return message.MarshalJSON(r)
}

func (r *ResponseVerificationHeader) UnmarshalJSON(data []byte) error {
	return message.UnmarshalJSON(r, data, new(session.ResponseVerificationHeader))
}

func (x *ContainerSessionContext) MarshalJSON() ([]byte, error) {
	return message.MarshalJSON(x)
}

func (x *ContainerSessionContext) UnmarshalJSON(data []byte) error {
	return message.UnmarshalJSON(x, data, new(session.ContainerSessionContext))
}
